# Threema MsgApi SDK - PHP
## Changelog

This changelog lists the most important changes for each released version. For
the full log, please refer to the git commit history.
* 2.1.1
  * Added the “isQuote” and “getQuotedMessageId” helper functions to the “GroupTextMessage” and “TextMessage” message types to facilitate determining message quotes.
  * Miscellaneous bugfixes
  * Updated dependencies
* 2.1.0
  * The prefixes “private:” and “public:” are no longer required when passing keys via CLI
  * Added new message type: GroupDeliveryReceipt
  * Fixed delivery receipt serialization
  * Added missing release notes (1.6.2–1.9.1) to changelog
  * Miscellaneous other improvements
* 2.0.3
  * Fixed a bug in some CLI commands
* 2.0.2
  * Miscellaneous bugfixes
  * Various other improvements and changes
* 2.0
  * **Breaking changes**:
    * Various enums such as “DeliveryReceiptType,” “ResultsDisclosureType,” and “VotingMode” replaced the previous integer-based type mappings
  * Deserialization of additional message types is now supported
  * Updated PHP language level to PHP 8.1
  * Updated Sodium
  * Various other improvements and changes
* 1.9.1
  * Fixed nullable display mode
* 1.9.0
  * Extended polls with summary mode
* 1.8.0
  * Added blob persistence flag in case of multiple recipients
* 1.7.0
  * Added poll message types
* 1.6.3
  * Removed obsolete group file message key “n”
* 1.6.2
  * Fixed a bug that occurred when using “array_merge”
* 1.6.1
  * Miscellaneous bug fixes and security improvements
* 1.6
  * Fixed group file handling (upload one blob for all group message recipients)
* 1.5.6
  * Supporting of group and normal location messages
* 1.4
  * Composer support
* 1.3.4
  * More options for E2E messages
* 1.3.3
  * URL fromString method
* 1.3.2
  * Read exif tags only on receiving image messages
  * Support file message captions
* 1.3.1
  * Fetch caption from image and file message
* 1.3
  * Support group text messages (send and receive)
* 1.2
  * Integrate bulk lookup
  * Send video Messages
* 1.1.8
  * Fix command tests
* 1.1.7
  * Add support for ”user decline” (thumbs down) delivery receipt type
* 1.1.6
  * Fix bug in PHP keystore
  * Fix SALT random generator (failed if only one bytes was requested and this happened to be '0')
* 1.1.5
  * use salt random instead mt_rand for padding (file and image messages)
* 1.1.4
  * use salt random instead mt_rand for padding (text messages)
