<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\Console\Command;

use Threema\Console\Common;
use Threema\MsgApi\Core\Exception;
use Threema\MsgApi\Tools\CryptTool;

class HashEmail extends Base
{
	final public const argEmail = 'email';

	public function __construct()
	{
		parent::__construct(
			'Hash Email Address',
			[self::argEmail],
			'Hash an email address for identity lookup. Prints the hash in hex.'
		);
	}

	/**
	 * @throws Exception
	 */
	public function doRun()
	{
		$email = $this->getArgument(self::argEmail);
		Common::required($email);
		$hashedEmail = CryptTool::getInstance()->hashEmail($email);
		Common::l($hashedEmail);
	}
}
