<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\Console\Command;

use Threema\Console\Common;
use Threema\MsgApi\Core\Exception;
use Threema\MsgApi\Tools\CryptTool;

class HashPhone extends Base
{
	final public const argPhoneNo = 'phoneNo';

	public function __construct()
	{
		parent::__construct(
			'Hash Phone Number',
			[self::argPhoneNo],
			'Hash a phone number for identity lookup. Prints the hash in hex.'
		);
	}

	/**
	 * @throws Exception
	 */
	public function doRun()
	{
		$phoneNo = $this->getArgument(self::argPhoneNo);
		Common::required($phoneNo);
		$hashedPhoneNo = CryptTool::getInstance()->hashPhoneNo($phoneNo);
		Common::l($hashedPhoneNo);
	}
}
