<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands;

use Threema\MsgApi\Commands\Results\DownloadFileResult;

class DownloadFile implements CommandInterface
{
	public function __construct(private readonly string $blobId)
	{
	}

	public function getParams(): array
	{
		return [];
	}

	public function getPath(): string
	{
		return 'blobs/' . $this->blobId;
	}

	public function parseResult(int $httpCode, string $res): DownloadFileResult
	{
		return new DownloadFileResult($httpCode, $res);
	}
}
