<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands;

use Threema\MsgApi\Commands\Results\FetchPublicKeyResult;

class FetchPublicKey implements CommandInterface
{
	public function __construct(private readonly string $threemaId)
	{
	}

	public function getParams(): array
	{
		return [];
	}

	public function getPath(): string
	{
		return 'pubkeys/' . urlencode($this->threemaId);
	}

	public function parseResult(int $httpCode, string $res): FetchPublicKeyResult
	{
		return new FetchPublicKeyResult($httpCode, $res);
	}
}
