<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands;

use Threema\MsgApi\Commands\Results\FetchPublicKeyBulkResult;

class FetchPublicKeyBulk implements JsonCommandInterface
{
	public function __construct(private readonly array $threemaIds)
	{
	}

	public function getParams(): array
	{
		return [];
	}

	public function getPath(): string
	{
		return 'pubkeys/bulk';
	}

	public function parseResult(int $httpCode, string $res): FetchPublicKeyBulkResult
	{
		return new FetchPublicKeyBulkResult($httpCode, $res);
	}

	public function getData(): array
	{
		return [
			'identities' => array_values($this->threemaIds)
		];
	}
}
