<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands;

use Threema\MsgApi\Commands\Results\LookupIdResult;
use Threema\MsgApi\Tools\CryptTool;

class LookupEmail implements CommandInterface
{
	public function __construct(private readonly string $emailAddress)
	{
	}

	public function getEmailAddress(): string
	{
		return $this->emailAddress;
	}

	public function getParams(): array
	{
		return [];
	}

	public function getPath(): string
	{
		return 'lookup/email_hash/' . urlencode(CryptTool::getInstance()->hashEmail($this->emailAddress));
	}

	public function parseResult(int $httpCode, string $res): LookupIdResult
	{
		return new LookupIdResult($httpCode, $res);
	}
}
