<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands;

use Threema\MsgApi\Commands\Results\LookupIdResult;
use Threema\MsgApi\Tools\CryptTool;

class LookupPhone implements CommandInterface
{
	public function __construct(private string $phoneNumber)
	{
	}

	public function getPhoneNumber(): string
	{
		return $this->phoneNumber;
	}

	public function getParams(): array
	{
		return [];
	}

	public function getPath(): string
	{
		return 'lookup/phone_hash/' . urlencode(CryptTool::getInstance()->hashPhoneNo($this->phoneNumber));
	}

	public function parseResult(int $httpCode, string $res): LookupIdResult
	{
		return new LookupIdResult($httpCode, $res);
	}
}
