<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands\Results;

class CreditsResult extends Result
{
	private ?int $credits = null;

	protected function processResponse(?string $response): void
	{
		$this->credits = intval((string)$response, 10);
	}

	protected function getErrorMessageByErrorCode(int $httpCode): string
	{
		return match ($httpCode) {
			401 => 'API identity or secret incorrect',
			500 => 'A temporary internal server error has occurred',
			default => 'Unknown error',
		};
	}

	public function getCredits(): ?int
	{
		return $this->credits;
	}
}
