<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands\Results;

class DownloadFileResult extends Result
{
	private ?string $data = null;

	protected function processResponse(?string $data): void
	{
		$this->data = $data;
	}

	protected function getErrorMessageByErrorCode(int $httpCode): string
	{
		return match ($httpCode) {
			401 => 'API identity or secret incorrect',
			404 => 'Invalid blob id',
			500 => 'A temporary internal server error has occurred',
			default => 'Unknown error',
		};
	}

	/**
	 * the generated blob id
	 */
	public function getData(): ?string
	{
		return $this->data;
	}
}
