<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands\Results;

class FetchPublicKeyResult extends Result
{
	private ?string $publicKey = null;

	protected function processResponse(?string $response): void
	{
		$this->publicKey = (string)$response;
	}

	protected function getErrorMessageByErrorCode(int $httpCode): string
	{
		return match ($httpCode) {
			401 => 'API identity or secret incorrect',
			404 => 'No matching ID found',
			500 => 'A temporary internal server error has occurred',
			default => 'Unknown error',
		};
	}

	public function getPublicKey(): ?string
	{
		return $this->publicKey;
	}
}
