<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands\Results;

class LookupIdResult extends Result
{
	private ?string $id = null;

	protected function processResponse(?string $response): void
	{
		$this->id = $response;
	}

	protected function getErrorMessageByErrorCode(int $httpCode): string
	{
		return match ($httpCode) {
			400 => 'Hash length is wrong',
			401 => 'API identity or secret incorrect',
			404 => 'No matching ID found',
			500 => 'A temporary internal server error has occurred',
			default => 'Unknown error',
		};
	}

	public function getId(): ?string
	{
		return $this->id;
	}
}
