<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands\Results;

class SendSimpleResult extends Result
{
	private ?string $messageId = null;

	protected function processResponse(?string $response): void
	{
		$this->messageId = (string)$response;
	}

	protected function getErrorMessageByErrorCode(int $httpCode): string
	{
		return match ($httpCode) {
			400 => 'The recipient identity is invalid or the account is not set up for basic mode',
			401 => 'API identity or secret incorrect',
			402 => 'No credits remain',
			404 => 'Phone or email could not be found',
			413 => 'Message is too long',
			500 => 'A temporary internal server error has occurred',
			default => 'Unknown error',
		};
	}

	public function getMessageId(): ?string
	{
		return $this->messageId;
	}
}
