<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands\Results;

class UploadFileResult extends Result
{
	private ?string $blobId = null;

	protected function processResponse(?string $blobId): void
	{
		$this->blobId = (string)$blobId;
	}

	protected function getErrorMessageByErrorCode(int $httpCode): string
	{
		return match ($httpCode) {
			401 => 'API identity or secret incorrect or file is empty',
			402 => 'No credits remain',
			413 => 'File is too long',
			500 => 'A temporary internal server error has occurred',
			default => 'Unknown error',
		};
	}

	/**
	 * the generated blob id
	 */
	public function getBlobId(): ?string
	{
		return $this->blobId;
	}
}
