<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands;

use Threema\MsgApi\Commands\Results\SendSimpleResult;
use Threema\MsgApi\Receiver;

class SendSimple implements CommandInterface
{
	public function __construct(private readonly Receiver $receiver, private string $text)
	{
	}

	public function getText(): string
	{
		return $this->text;
	}

	public function getParams(): array
	{
		$p = $this->receiver->getParams();
		$p['text'] = $this->getText();

		return $p;
	}

	public function getPath(): string
	{
		return 'send_simple';
	}

	public function parseResult(int $httpCode, string $res): SendSimpleResult
	{
		return new SendSimpleResult($httpCode, $res);
	}
}
