<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Commands;

use Threema\MsgApi\Commands\Results\UploadFileResult;

class UploadFile implements MultiPartCommandInterface
{
	public function __construct(private readonly string $encryptedFileData, private readonly ?bool $persist = false)
	{
	}

	public function getParams(): array
	{
		if (true === $this->persist) {
			return ['persist' => 1];
		}

		return [];
	}

	public function getPath(): string
	{
		return 'upload_blob';
	}

	public function getData(): string
	{
		return $this->encryptedFileData;
	}

	public function parseResult(int $httpCode, string $res): UploadFileResult
	{
		return new UploadFileResult($httpCode, $res);
	}
}
