<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Helpers;

use Threema\MsgApi\Commands\Results\UploadFileResult;
use Threema\MsgApi\Tools\CryptTool;
use Threema\MsgApi\Tools\EncryptResult;
use Threema\MsgApi\Tools\FileAnalysisResult;

interface ProcessFileSend
{
	public function process(
		CryptTool $cryptTool,
		string $privateKey,
		UploadFileResult $uploadResult,
		EncryptResult $encryptionResult,
		FileAnalysisResult $fileAnalysisResult,
		string $receiverPublicKey,
		string $nonce,
		?UploadFileResult $thumbnailUploadResult,
		?string $thumbnailMimeType,
		?string $caption
	): string;
}
