<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Helpers;

final class ProcessFileSendResult
{
	public function __construct(protected string $threemaId, protected ?string $nonce, protected ?string $box)
	{
	}

	public function getThreemaId(): string
	{
		return $this->threemaId;
	}

	public function getBox(): ?string
	{
		return $this->box;
	}

	public function getNonce(): ?string
	{
		return $this->nonce;
	}

	public function success(): bool
	{
		return !empty($this->box);
	}
}
