<?php
/**
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Messages;

use Stringable;
use Threema\MsgApi\Types\GroupId;

/**
 * @deprecated
 */
class GroupImageMessage extends ThreemaGroupMessage implements Stringable
{
	final public const TYPE_CODE = 0x43;

	public function __construct(
		GroupId $groupId,
		private readonly string $blobId,
		private readonly int $blobLength,
		private readonly string $encryptionKey
	) {
		parent::__construct($groupId);
	}

	public function __toString(): string
	{
		return 'group image message';
	}

	public function getBlobId(): string
	{
		return $this->blobId;
	}

	public function getBlobLength(): int
	{
		return $this->blobLength;
	}

	public function getEncryptionKey(): string
	{
		return $this->encryptionKey;
	}

	/**
	 * Get the message type code of this message.
	 *
	 * @return int message type code
	 */
	public function getTypeCode(): int
	{
		return self::TYPE_CODE;
	}
}
