<?php
/**
 * ThreemaMessage
 *
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * The version of the model input document: 1
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Messages;

use Closure;
use Exception;
use JsonSerializable;
use Stringable;
use Threema\MsgApi\Serializers;
use Threema\MsgApi\Tools\Util;

/**
 * ThreemaMessage Class Doc Comment
 *
 * @category Class
 * @author   Threema Gateway team
 * @see     https://gateway.threema.ch/en/developer
 */
abstract class ThreemaMessage implements JsonSerializable, Stringable
{
	public function __toArray(): array
	{
		return array_filter([
		], fn ($v) => Util::array_filter_callback($v));
	}

	/**
	 * Data that can be natively serialized by `json_encode()`.
	 */
	public function jsonSerialize(): string|array
	{
		return $this->__toArray();
	}

	/**
	 * The deserialized ThreemaMessage.
	 *
	 * @throws Exception
	 */
	public static function fromString(string $data, int $realDataLength, Closure $piece): ThreemaMessage
	{
		Serializers\ThreemaMessageSerializer::validate($data, $realDataLength);

		return Serializers\ThreemaMessageSerializer::deserialize($data, $piece);
	}

	/**
	 * Show all the invalid properties with reasons.
	 *
	 * @return array invalid properties with reasons
	 */
	public function listInvalidProperties(): array
	{
		return [];
	}

	/**
	 * Validate all the properties in the model
	 * return true if all passed
	 *
	 * @return bool True if all properties are valid
	 */
	public function valid(): bool
	{
		return count($this->listInvalidProperties()) === 0;
	}

	/**
	 * Get the message type code of this message.
	 *
	 * @return int message type code
	 */
	abstract public function getTypeCode(): int;
}
