<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Constants;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Messages\DeliveryReceipt;
use Threema\MsgApi\Types\DeliveryReceiptType;
use Threema\MsgApi\Types\GroupId;

class DeliveryReceiptSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function deserialize(string $data, Closure $piece): DeliveryReceipt
	{
		$receiptType = ord($data[1] ?? 0);
		$messageIds = str_split(substr($data, 2), Constants::MESSAGE_ID_LEN);

		return new DeliveryReceipt(DeliveryReceiptType::tryFrom($receiptType), $messageIds);
	}

	/**
	 * @throws Exception
	 */
	public static function extractGroupId(Closure $piece): GroupId
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function validate(string $data, int $realDataLength): void
	{
		if ($realDataLength < (Constants::MESSAGE_ID_LEN - 2) || 0 != (($realDataLength - 2) % Constants::MESSAGE_ID_LEN)) {
			throw new BadMessageException();
		}
	}
}
