<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Core\AssocArray;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Messages\FileMessage;
use Threema\MsgApi\Types\FileRenderingType;
use Threema\MsgApi\Types\GroupId;

class FileMessageSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws BadMessageException
	 * @throws \Threema\MsgApi\Core\Exception
	 */
	public static function deserialize(string $data, Closure $piece): FileMessage
	{
		$decodeResult = json_decode(substr($data, 1), true);
		if (null === $decodeResult || false === $decodeResult) {
			throw new BadMessageException();
		}

		$values = AssocArray::byJsonString(substr($data, 1), ['b', 'k', 'm', 'n', 's']);
		if (null === $values) {
			throw new BadMessageException();
		}

		return new FileMessage(
			$values->getValue('m'),
			$values->getValue('s'),
			$values->getValue('b'),
			$values->getValue('k'),
			$values->getValue('t'),
			$values->getValue('p'),
			$values->getValue('d'),
			FileRenderingType::FILE::tryFrom($values->getValue('j')),
			$values->getValue('c'),
			$values->getValue('x'),
			$values->getValue('n'),
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractGroupId(Closure $piece): GroupId
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function validate(string $data, int $realDataLength): void
	{
//		throw new Exception('Not implemented.');
	}
}
