<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Constants;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Messages\GroupCreateMessage;
use Threema\MsgApi\Types\GroupId;

class GroupCreateMessageSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function deserialize(string $data, Closure $piece): GroupCreateMessage
	{
		$groupId = self::extractGroupId($piece);
		$members = [];
		for ($i = 1; $i < strlen($data); $i += Constants::IDENTITY_LEN) {
			$members[] = substr($data, $i, Constants::IDENTITY_LEN);
		}

		return new GroupCreateMessage(
			$groupId,
			$members
		);
	}

	public static function extractGroupId(Closure $piece): GroupId
	{
		return new GroupId(
			'',
			$piece->__invoke(Constants::GROUP_ID_LEN)
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function validate(string $data, int $realDataLength): void
	{
		if ($realDataLength < (1 + Constants::GROUP_ID_LEN + Constants::IDENTITY_LEN) || 0 !== ($realDataLength - 1) % 8) {
			throw new BadMessageException('invalid group create message length');
		}
	}
}
