<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Constants;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Messages\GroupDeliveryReceipt;
use Threema\MsgApi\Types\DeliveryReceiptType;
use Threema\MsgApi\Types\GroupId;

class GroupDeliveryReceiptSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function deserialize(string $data, Closure $piece): GroupDeliveryReceipt
	{
		$groupId = self::extractGroupId($piece);

		$receiptType = DeliveryReceiptType::tryFrom(ord($data[Constants::IDENTITY_LEN + Constants::GROUP_ID_LEN + 1] ?? 0));
		if (false === in_array($receiptType, [DeliveryReceiptType::USER_ACK, DeliveryReceiptType::USER_DEC])) {
			throw new BadMessageException();
		}
		$messageIds = str_split(substr($data, 2 * Constants::GROUP_ID_LEN + 2), Constants::MESSAGE_ID_LEN);

		return new GroupDeliveryReceipt($groupId, $receiptType, $messageIds);
	}

	/**
	 * @throws Exception
	 */
	public static function extractGroupId(Closure $piece): GroupId
	{
		return new GroupId(
			$piece->__invoke(Constants::IDENTITY_LEN),
			$piece->__invoke(Constants::GROUP_ID_LEN)
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function validate(string $data, int $realDataLength): void
	{
		if ($realDataLength < (2 * Constants::GROUP_ID_LEN + Constants::MESSAGE_ID_LEN - 2) || 0 != (($realDataLength - 2) % Constants::MESSAGE_ID_LEN)) {
			throw new BadMessageException();
		}
	}
}
