<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Constants;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Exceptions\UnsupportedMessageTypeException;
use Threema\MsgApi\Messages\GroupLeaveMessage;
use Threema\MsgApi\Types\GroupId;

class GroupLeaveMessageSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function deserialize(string $data, Closure $piece): GroupLeaveMessage
	{
		return new GroupLeaveMessage(self::extractGroupId($piece));
	}

	public static function extractGroupId(Closure $piece): GroupId
	{
		return new GroupId(
			$piece->__invoke(Constants::IDENTITY_LEN),
			$piece->__invoke(Constants::GROUP_ID_LEN)
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws UnsupportedMessageTypeException
	 */
	public static function validate(string $data, int $realDataLength): void
	{
		if ($realDataLength !== (1 + Constants::IDENTITY_LEN + Constants::GROUP_ID_LEN)) {
			throw new UnsupportedMessageTypeException('invalid group leave message length');
		}
	}
}
