<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Constants;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Messages\GroupRenameMessage;
use Threema\MsgApi\Types\GroupId;

class GroupRenameMessageSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function deserialize(string $data, Closure $piece): GroupRenameMessage
	{
		$groupId = self::extractGroupId($piece);
		$name = substr($data, 1 + Constants::GROUP_ID_LEN);

		return new GroupRenameMessage(
			$groupId,
			$name
		);
	}

	public static function extractGroupId(Closure $piece): GroupId
	{
		return new GroupId(
			'',
			$piece->__invoke(Constants::GROUP_ID_LEN)
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function validate(string $data, int $realDataLength): void
	{
		if ($realDataLength < (1 + Constants::GROUP_ID_LEN)) {
			throw new BadMessageException('Invalid group rename message length.');
		}
	}
}
