<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Constants;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Messages\GroupSetPhoto;
use Threema\MsgApi\Types\GroupId;

class GroupSetPhotoSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function deserialize(string $data, Closure $piece): GroupSetPhoto
	{
		$groupId = self::extractGroupId($piece);
		$blobId = bin2hex(substr($data, 1 + Constants::GROUP_ID_LEN, Constants::BLOB_ID_LEN));
		$size = unpack('V', $data, 1 + Constants::GROUP_ID_LEN + Constants::BLOB_ID_LEN);
		$key = substr($data, -Constants::SYMMETRIC_KEY_LEN);

		return new GroupSetPhoto(
			$groupId,
			$size[1],
			$blobId,
			$key
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractGroupId(Closure $piece): GroupId
	{
		return new GroupId(
			'',
			$piece->__invoke(Constants::GROUP_ID_LEN)
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws BadMessageException
	 */
	public static function validate(string $data, int $realDataLength): void
	{
		if ($realDataLength !== (1 + Constants::GROUP_ID_LEN + Constants::BLOB_ID_LEN + 4 + Constants::SYMMETRIC_KEY_LEN)) {
			throw new BadMessageException('Invalid group set photo message length');
		}
	}
}
