<?php
/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Serializers;

use Closure;
use Exception;
use Threema\MsgApi\Exceptions\BadMessageException;
use Threema\MsgApi\Messages\LocationMessage;
use Threema\MsgApi\Types\GroupId;

class LocationMessageSerializer implements CustomMessageSerializer
{
	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function serialize(): string
	{
		throw new Exception('Not implemented.');
	}

	public static function deserialize(string $data, Closure $piece): LocationMessage
	{
		$locationStrings = explode("\n", substr($data, 1));
		$pieces = explode(',', $locationStrings[0]);

		$latitude = doubleval($pieces[0]);
		$longitude = doubleval($pieces[1]);
		$accuracy = null;
		if (count($pieces) >= 3) {
			$accuracy = doubleval($pieces[2]);
		}

		$poiName = null;
		$poiAddress = null;

		if (count($locationStrings) >= 2) {
			$poiName = $locationStrings[1];

			if (count($locationStrings) >= 3) {
				$poiAddress = str_replace('\n', "\n", $locationStrings[2]);
			}
		}

		return new LocationMessage(
			$latitude,
			$longitude,
			$poiAddress,
			$accuracy,
			$poiName
		);
	}

	/**
	 * @throws Exception
	 */
	public static function extractGroupId(Closure $piece): GroupId
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws Exception
	 */
	public static function extractJson(string $data): string
	{
		throw new Exception('Not implemented.');
	}

	/**
	 * @throws BadMessageException
	 * @throws Exception
	 */
	public static function validate(string $data, int $realDataLength): void
	{
		if ($realDataLength < 4) {
			throw new BadMessageException();
		}
	}
}
