<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Tools;

/**
 * Result of a Data Encryption
 */
class EncryptResult
{
	public function __construct(private $data, private readonly string $key, private readonly string $nonce, private readonly int $size)
	{
	}

	public function getSize(): int
	{
		return $this->size;
	}

	/**
	 * @return string (binary)
	 */
	public function getKey(): string
	{
		return $this->key;
	}

	/**
	 * @return string (binary)
	 */
	public function getNonce(): string
	{
		return $this->nonce;
	}

	/**
	 * @return string (binary)
	 */
	public function getData(): string
	{
		return $this->data;
	}
}
