<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Tools;

class FileAnalysisResult
{
	private string $path;

	public function __construct(private readonly string $mimeType, private readonly int $size, string $path, private readonly array $exifTags = [])
	{
		$this->path = realpath($path);
		$this->path = $path;
	}

	public function getMimeType(): string
	{
		return $this->mimeType;
	}

	public function getSize(): int
	{
		return $this->size;
	}

	public function getPath(): string
	{
		return $this->path;
	}

	public function getFileName(): string
	{
		return basename($this->path);
	}

	public function getExifTags(): array
	{
		return $this->exifTags;
	}
}
