<?php
/**
 * @author Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see https://gateway.threema.ch/en/developer
 */

namespace Threema\MsgApi\Types;

use Stringable;
use Threema\MsgApi\Core\Exception;

class GroupId implements Stringable
{
	public function __construct(private string $groupCreator, private readonly string $groupId)
	{
	}

	public function __toString()
	{
		return 'GroupId{creator=' . $this->groupCreator . ', '
			. 'groupId=' . $this->groupId . '}';
	}

	/**
	 * @return string
	 */
	public function getGroupCreator()
	{
		return $this->groupCreator;
	}

	/**
	 * @throws Exception
	 * @return $this
	 */
	public function setGroupCreator(string $creator): GroupId
	{
		if (!empty($this->groupCreator)) {
			throw new Exception('Creator already set');
		}
		$this->groupCreator = $creator;

		return $this;
	}

	public function getGroupId(): string
	{
		return $this->groupId;
	}
}
