<?php
/**
 * VoteChoice
 *
 * PHP version 8.1
 *
 * @category  Class
 * @author    Threema Gateway team
 * @copyright Copyright (c) 2023 Threema GmbH
 * @see       https://gateway.threema.ch/en/developer
 */

/**
 * Threema Gateway Php SDK
 *
 * This SDK allows for preparing, sending and receiving of Threema Messages via Threema Gateway.
 *
 * The version of the model input document: 1
 * Generated by: https://gateway.threema.ch/en/developer
 * MsgApi SDK Generator version: 0.1.0
 */

namespace Threema\MsgApi\Types\Voting;

use JsonSerializable;
use Stringable;
use Threema\MsgApi\Tools\Util;

/**
 * VoteChoice Class Doc Comment
 *
 * @category Class
 * @description A vote choice item that is part of a vote message.
 * @author   Threema Gateway team
 * @see     https://gateway.threema.ch/en/developer
 */
class VoteChoice implements JsonSerializable, Stringable
{
	public function __construct(
		private readonly int $choiceId,
		private readonly bool $selected
	) {
	}

	public function __toArray(): array
	{
		return array_filter([
			$this->getChoiceId(),
			(int)$this->getSelected()
		], fn ($v) => Util::array_filter_callback($v));
	}

	/**
	 * Gets the string presentation of the object
	 */
	public function __toString(): string
	{
		return 'Vote{' . 'choiceId=' . $this->choiceId . ', '
			. 'selected=' . (int)$this->selected . '}';
	}

	/**
	 * Data that can be natively serialized by `json_encode()`.
	 */
	public function jsonSerialize(): string|array
	{
		return $this->__toArray();
	}

	/**
	 * Show all the invalid properties with reasons.
	 *
	 * @return array invalid properties with reasons
	 */
	public function listInvalidProperties(): array
	{
		$invalidProperties = [];

		if (null === $this->choiceId) {
			$invalidProperties[] = "'choiceId' can't be null";
		}
		if (null === $this->selected) {
			$invalidProperties[] = "'selected' can't be null";
		}

		return $invalidProperties;
	}

	/**
	 * Validate all the properties in the model
	 * return true if all passed
	 *
	 * @return bool True if all properties are valid
	 */
	public function valid(): bool
	{
		return count($this->listInvalidProperties()) === 0;
	}

	/**
	 * Gets ballotId
	 */
	public function getChoiceId(): int
	{
		return $this->choiceId;
	}

	/**
	 * Gets selected
	 */
	public function getSelected(): bool
	{
		return $this->selected;
	}
}
